import pathlib

from .interfaces import DestinationDecorator, Destination


class SubdirectoryDecorator(DestinationDecorator):
    """
    A wrapper for making it easy to descend to subdirectories during delivery.
    """

    def __init__(self, underlying: Destination, subdirectory: str):
        super().__init__(underlying)
        self.subdirectory = subdirectory

    def add_file(self, file: pathlib.Path, relative_path: str):
        self.underlying.add_file(file, self.subdirectory + "/" + relative_path)
